package sample;

import java.util.Properties;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingEnumeration;
import javax.naming.NamingException;
import javax.naming.*;

import org.jboss.ejb.client.ContextSelector;
import org.jboss.ejb.client.EJBClientConfiguration;
import org.jboss.ejb.client.PropertiesBasedEJBClientConfiguration;
import org.jboss.ejb.client.remoting.ConfigBasedEJBClientContextSelector;
import org.jboss.ejb.client.EJBClientContext;

public class Client610 {

	public static void main(String argv[]) throws Exception {
		Client610 client = new Client610();
		//client.invokeEjbByAnonymous();
		client.invokeEjbByValidUser();
		//java.lang.Thread.sleep(3 * 1000);
	}
	

	void invokeEjbByValidUser() throws Exception {

		Properties prop = new Properties();
		prop.put("endpoint.name", "aaa");
        prop.put("org.jboss.ejb.client.scoped.context", "true");
        prop.put("remote.connectionprovider.create.options.org.xnio.Options.SSL_ENABLED", "false");
        prop.put("remote.connections", "default");
        prop.put("remote.connection.default.host", "127.0.0.1");
        prop.put("remote.connection.default.port", "4447");
        prop.put("remote.connection.default.connect.options.org.xnio.Options.SASL_POLICY_NOANONYMOUS", "true");
        prop.put("remote.connection.default.connect.options.org.xnio.Options.SASL_POLICY_NOPLAINTEXT", "false");
        prop.put("remote.connection.default.username", "ejbuser");
        prop.put("remote.connection.default.password", "ejbuser");

        prop.put("remote.clusters", "ejb");
        prop.put("remote.cluster.ejb.connect.options.org.xnio.Options.SASL_POLICY_NOANONYMOUS", "true");
        prop.put("remote.cluster.ejb.connect.options.org.xnio.Options.SSL_ENABLED", "true");
        prop.put("remote.cluster.ejb.connect.options.org.xnio.Options.SASL_POLICY_NOPLAINTEXT", "false");
        prop.put("remote.cluster.ejb.username", "ejbuser");
        prop.put("remote.cluster.ejb.password", "ejbuser");

        prop.put(Context.URL_PKG_PREFIXES, "org.jboss.ejb.client.naming");
		Context context = new InitialContext(prop);

		//String lookedup = "ejb:/samplebz//SecureHelloBean!sample.Hello?stateful";
		String lookedup = "hoge/Hello";
		Hello hello = (Hello) context.lookup(lookedup);
		try {
			String message = hello.hello();
			System.out.println("  ====>>>> UnsecureHelloBean invoked by ejbuser returned '" + message + "'");
		} catch (Exception e) {
			System.out.println("  ====>>>> invocation failed : " + e.getMessage());
		}
	}
}
